﻿if (!app.documents.length || !app.windows.length) exit();

doc = app.activeDocument;
layoutWindow = doc.layoutWindows[0];
currSpread = layoutWindow.activeSpread;

Array.prototype.map = function(fun) {
    var mappedValue = [];
    
    (function(arr, n) {
        mappedValue[n] = fun.call(arr, arr[n]);
        if (n + 1 < arr.length) arguments.callee(arr, n + 1);
    })(this, 0);
    
    return mappedValue;
};


// имена разворотов
spreadNames = doc.spreads.everyItem().getElements().map(function(spread) {
    return spread.pages.everyItem().name.join('-');
});

// диалог
dialog = new Window ("dialog", "Paste to Pages");

// список страниц
listbox = dialog.add (
    "listbox", 
    undefined, 
    spreadNames, 
    {multiselect: true});
listbox.minimumSize = {width: 99,  height: 9};
listbox.maximumSize = {width: 333, height: 777};
listbox.onDoubleClick = function(){listbox.selection = listbox.items;};

// кнопки
dialog.add ("button", undefined,"OK");
dialog.add ("button", undefined,"Cancel");

// отобразим диалог
if (2 == dialog.show() || !listbox.selection) exit();

// обработка выделенных элементов
listbox.selection.map(function(item) {
    // переход на нужный разворот
    layoutWindow.activeSpread = doc.spreads[item.index];
    
    // вставка
    app.pasteInPlace();
});

// восстановим первоначальную страницу
layoutWindow.activeSpread = currSpread;
